using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace UHFAPP
{
    public class UHFAPI
    {
          //打开串口
		   Open serial port

        [DllImport("UHFAPI.dll")]
        private extern static int ComOpen(int comName);
          //关闭串口
		  Close serial port
          [DllImport("UHFAPI.dll")]
        private extern static void ClosePort();
    
          /**********************************************************************************************************
             * 功能：获取硬件版本号
			  Function: Get hardware version
             * 输出：version[0]--版本号长度 ,  version[1--x]--版本号
			  Output: version[0]--Veersion Length, Version[1--x]--Version number.
             *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetHardwareVersion(byte[] version);
          /**********************************************************************************************************
            * 功能：获取软件版本号
			  Function: Get software version.
            * 输出：version[0]--版本号长度 ,  version[1--x]--版本号
			  Output:version[0]--Veersion Length, Version[1--x]--Version number.
            *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetSoftwareVersion(byte[] version);
          /**********************************************************************************************************
             * 功能：获取ID号
			 Function: Get ID
             * 输出：id--整型ID号
			  Output:ID--Get the UHF module ID number
             *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetDeviceID(ref int id);

          /**********************************************************************************************************
          * 功能：设置功率
		    Function: Set fequency
          * 输入：saveflag  -- 1:保存设置   0：不保存
		    Input:saveflag  -- 1: save settings 0: cancel
          * 输入：uPower -- 功率（DB）
		    Input: uPower-- Power(DB)
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetPower(byte save, byte uPower);
          /**********************************************************************************************************
          * 功能：获取功率
		  Function: Get frequency
          * 输出：uPower -- 功率（DB）
		  Output : uPower  --Power (DB)
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetPower(ref byte uPower);
          /**********************************************************************************************************
          * 功能：设置跳频
		  Function: Set frequency hop
          * 输入：nums -- 跳频个数
		  Input:  :nums-- hop numbers
          * 输入：Freqbuf--频点数组（整型） ，如920125，921250.....
		  Input: Freqbuf--  Frequency hop array, for example: 920125.921250......
         *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetJumpFrequency(byte nums, int[] Freqbuf);
          /**********************************************************************************************************
          * 功能：获取跳频
		  Function:Get frequency hop.
          * 输出：Freqbuf[0]--频点个数， Freqbuf[1]..[x]--频点数组（整型）
		  Output:  Freqbuf[0]--Frequency hop numbers， Freqbuf[1]..[x]--Frequency hop array
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetJumpFrequency(int[] Freqbuf);
          /**********************************************************************************************************
          * 功能：设置Gen2参数
		  Function: Set Gen2 parameters
          * 输入：
		  Input:
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetGen2(byte Target, byte Action, byte T, byte Q, byte StartQ, byte MinQ, byte MaxQ, byte D, byte C, byte P, byte Sel, byte Session, byte G, byte LF);
          /**********************************************************************************************************
          * 功能：获取Gen2参数
		  Function: Set Gen2 parameters
          * 输入：
		  Input :
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetGen2(ref byte Target, ref byte Action, ref byte T, ref byte Q, ref byte StartQ, ref byte MinQ, ref byte MaxQ, ref byte D, ref byte Coding, ref byte P, ref byte Sel, ref byte Session, ref byte G, ref byte LF);
          /**********************************************************************************************************
          * 功能：设置CW
		  Function:Set CW
          * 输入：flag -- 1:开CW，  0：关CW
		  Input: flag--1: open CW,  0: Close CW.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetCW(byte flag);
          /**********************************************************************************************************
          * 功能：获取CW
		  Function: Get CW.
          * 输出：flag -- 1:开CW，  0：关CW
		  Output: flag --1 .open CW, 0: Close CW.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetCW(ref byte flag);

          /**********************************************************************************************************
          * 功能：天线设置
		  Function: Antenna settings.
          * 输入：saveflag -- 1:掉电保存，  0：不保存
		  Input:  saveflag -- 1.power fail saving, 0: no saving.
          * 输入：buf--2bytes, 共16bits, 每bit 置1选择对应天线
		  Input: buf-2 bytes, 16bits in total, set as 1 for every bit to select correct antenna.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetANT(byte saveflag, byte[] buf);

          /**********************************************************************************************************
          * 功能：获取天线设置
		  Function: Get antenna settings 
          * 输出：buf--2bytes, 共16bits,
		  Output:  buf-- 2 bytes,16 bits in total.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetANT(byte[] buf);

          /**********************************************************************************************************
          * 功能：区域设置
		  Function: Region settings
          * 输入：saveflag -- 1:掉电保存，  0：不保存
		    Input:  saveflag -- 1.power fail saving, 0: no saving.
          * 输入：region -- 0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
		   Input :   region -- 0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetRegion(byte saveflag, byte region);

          /**********************************************************************************************************
          * 功能：获取区域设置
		  Function : Get region settings
          * 输出：region -- 0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
		  Output:   region -- 0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetRegion(ref byte region);

          /**********************************************************************************************************
          * 功能：获取当前温度
		  Fucntion: Get current temperature.
          * 输出：temperature -- 整型
		  Output: Tem[erature --Module
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetTemperature(ref int temperature);

          /**********************************************************************************************************
          * 功能：设置温度保护
		  Function: Set temperature protect.
          * 输入：flag -- 1:温度保护， 0：无温度保护
		   Input :   flag --  1: Temperature protect,  0: No temperature protect.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetTemperatureProtect(byte flag);
          /**********************************************************************************************************
          * 功能：获取温度保护
		  Function: Get temperature protect.
          * 输出：flag -- 1:温度保护， 0：无温度保护
		  Output:  flag --  1: Temperature protect,  0: No temperature protect.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetTemperatureProtect(ref byte flag);
          /**********************************************************************************************************
          * 功能：设置天线工作时间
		  Function: Set antenna working time.
          * 输入：antnum -- 天线号
		   Input :   antnum --  antenna number.
          * 输入：saveflag -- 1:掉电保存， 0：不保存
		  Output:  saveflag -- 1: Power fail saving, 0: No saving.
          * 输入：WorkTime -- 工作时间 ，单位ms, 范围 10-65535ms
		  Input :     WorkTime --  Working time ,  unit,ms,range 10-65535 ms.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetANTWorkTime(byte antnum, byte saveflag, int WorkTime);
          /**********************************************************************************************************
          * 功能：获取天线工作时间
		  Function: Get antenna working time
          * 输入：antnum -- 天线号
		  Input :     antnum --  antenna number.
          * 输出：WorkTime -- 工作时间 ，单位ms, 范围 10-65535ms
		  Output:  WorkTime --  Working time, unit ms, range 10-65535 ms
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetANTWorkTime(byte antnum, ref int WorkTime);
          /**********************************************************************************************************
          * 功能：设置链路组合
		  Function: Set RF link.
          * 输入：saveflag -- 1:掉电保存， 0：不保存
		  Input :     saveflag -- 1: power fail saving.0: No saving.
          * 输入：mode --  0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ
		  Input :     mode --  0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetRFLink(byte saveflag, byte mode);

          /**********************************************************************************************************
          * 功能：获取链路组合
		  Function : Get RF link.
          * 输出：mode --  0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ
		  Output:   mode --  0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetRFLink(ref byte uMode);
          /**********************************************************************************************************
          * 功能：设置FastID功能
		  Function: Set FastID function.
          * 输入：flag -- 1:开启， 0：关闭
		  Input   :   flag-- 1 : Open,  0 : Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetFastID(byte flag);
          /**********************************************************************************************************
          * 功能：获取FastID功能
		  Function: Get FastID function.
          * 输出：flag -- 1:开启， 0：关闭
		  Output:   flag-- 1: open,   0:  Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetFastID(ref byte flag);
          /**********************************************************************************************************
          * 功能：设置Tagfocus功能
		  Function: Set Tagfocus function.
          * 输入：flag -- 1:开启， 0：关闭
		  Input   :   flag -- 1: Open,  0:  Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetTagfocus(byte flag);
          /**********************************************************************************************************
          * 功能：获取Tagfocus功能
		  Function: Get Tagfocus function
          * 输出：flag -- 1:开启， 0：关闭
		  Output:  flag  -- 1: Open,  0:    Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetTagfocus(ref byte flag);
          /**********************************************************************************************************
          * 功能：设置软件复位
		  Function : Set software reset.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetSoftReset();
          /**********************************************************************************************************
          * 功能：设置Dual和Singel模式
		  Function: Set dual and Single mode
          * 输入：saveflag -- 1:掉电保存， 0：不保存
		  Input :     saveflag--  1: power fail saving, 0:No saving.
          * 输入：mode -- 1:设置Single模式， 0：设置Dual模式
		  Input  :   Mode --  1.Set single mode,    0:  Set dual mode.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetDualSingelMode(byte saveflag, byte mode);
          /**********************************************************************************************************
          * 功能：获取Dual和Singel模式
		  Function: Get dual and single mode
          * 输出：mode -- 1:设置Singel模式， 0：设置Dual模式
		  Output:   mode --1: Set single mode,    0:   Set dual mode.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetDualSingelMode(ref byte mode);
          /**********************************************************************************************************
          * 功能：设置寻标签过滤设置
		  Function: Set inventory tag filter.
          * 输入：saveflag -- 1:掉电保存， 0：不保存
		  Input :     saveflag -- 1: power fail savings,0 : No saving.
          * 输入：bank --  0x01:EPC , 0x02:TID, 0x03:USR
		   Input:      bank --  0x01:EPC , 0x02:TID, 0x03:USR
          * 输入：startaddr 起始地址，单位：字节
		   Input  :   startaddr Start adress, unit: byte
          * 输入：datalen 数据长度， 单位:字节
		   Input  :   datalen Datalength , unit: byte
          * 输入：databuf 数据
		   Input   :  databuf Data
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetFilter(byte saveflag, byte bank, int startaddr, int datalen, byte[] databuf);
          /**********************************************************************************************************
          * 功能：设置EPC和TID模式
		  Function : Set EPC+ TID mode.
          * 输入：saveflag -- 1:掉电保存， 0：不保存
		  Function: saveflag--1 : power fail saving, 0: No saving.
          * 输入：mode -- 1：开启EPC和TID， 0:关闭
		  Output : mode -- 1:  Open EPC+TID ,     0: Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetEPCTIDMode(byte saveflag, byte mode);
          /**********************************************************************************************************
          * 功能：获取EPC和TID模式
	      Function: Get EPC+ TID mode.
          * 输出：mode -- 1：开启EPC和TID， 0:关闭
		  Output:  mode  --1 :   Open EPC+ TID,   0 : Close.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetEPCTIDMode(ref byte mode);

          /**********************************************************************************************************
         * 功能：恢复出厂设置
		 Function : Restore factory default.
         *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetDefaultMode();
          /**********************************************************************************************************
          * 功能：单次盘存标签
		  Function: Singe inventory tag.
          * 输出：uLenUii -- UII长度
		  Output:  uLenUii -- UII length
          * 输出：uUii -- UII数据
		  Output:   uUii -- UII data
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFInventorySingle(ref byte uLenUii, byte[] uUii);
          /**********************************************************************************************************
          * 功能：连续盘存标签
		  Function : Inventory tag.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFInventory();
          /**********************************************************************************************************
          * 功能：停止盘存标签
		  Function: Stop inventory.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFStopGet();
          /**********************************************************************************************************
            * 功能：获取连续盘存标签数据
			Function : Get inventory tag data.
            * 输出：uLenUii -- UII长度
			Output:   uLenUii -- UII length
            * 输出：uUii -- UII数据
			Output:   uUii -- UII data
            *********************************************************************************************************/
         [DllImport("UHFAPI.dll")]
          private static extern int UHF_GetReceived_EX(ref int uLenUii, byte[] uUii);
         /**********************************************************************************************************
         * 功能：读标签数据区
		   Function: Read tag data banks.
         * 输入：uAccessPwd -- 4字节密码
		   Input :   uAccessPwd -- 4 bytes password
         * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input ：FilterBank -- Open filter bank number， 1：EPC, 2:TID, 3:USR
         * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		    Input：FilterStartaddr -- Open filter start address， unit: byte
         * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		    Input：FilterLen -- Open filter length， unit：byte
         * 输入：FilterData -- 启动过滤的数据
		   Input :   FilterData -- Open filter data
         * 输入：uBank -- 读取数据的bank
		   Input:    uBank -- Read data bank
         * 输入：uPtr --  读取数据的起始地址， 单位：字
		   Input:    uPtr --  Read data start address, unit:  word
         * 输入：uCnt --  读取数据的长度， 单位：字
		   Input:    uCnt --  read data length,unit: word
         * 输出：uReadDatabuf --  读取到的数据
		   Output: uReadDatabuf --  Data 
         * 输出：uReadDataLen --  读取到的数据长度
		   Output:  uReadDataLen --  Data length
         *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
         private static extern int UHFReadData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt, byte[] uReadDatabuf, ref int uReadDataLen);
          /**********************************************************************************************************
          * 功能：写标签数据区
		    Function: Write tag data block
          * 输入：uAccessPwd -- 4字节密码
		    Input :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input： FilterBank -- open filter bank， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：bit
		    Input :   FilterStartaddr -- Open filter start address， unit：bit
          * 输入：FilterLen -- 启动过滤的长度， 单位：bit
		    Input :  FilterLen --  Open filter length, unit: bit.
          * 输入：FilterData -- 启动过滤的数据
		    Input :  FilterData -- Open filter data
          * 输入：uBank -- 写入数据的bank
		    Input:    uBank -- Write data bank
          * 输入：uPtr --  写入数据的起始地址， 单位：字
		  	Input :   uPtr --  Write data start address,unit : word.
          * 输入：uCnt --  写入数据的长度， 单位：字
		    Input :   uCnt -- Write data length,unit : word.
          * 输入：uWriteDatabuf --  写入的数据
		    Input :   uWriteDatabuf --  Data
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFWriteData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf);
          /**********************************************************************************************************
          * 功能：LOCK标签
		   Function: LOCK tag.
          * 输入：uAccessPwd -- 4字节密码
		   Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		   Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		   Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		   Input  :   FilterData -- Open filter data
          * 输入：lockbuf --  3字节，第0-9位为Action位， 第10-19位为Mask位
		   Input  :   lockbuf --  3 bytes,0-9 is Action, 10-19 is Mask.
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFLockTag(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte[] lockbuf);

          /**********************************************************************************************************
          * 功能：KILL标签
		   Function : Kill tag
          * 输入：uAccessPwd -- 4字节密码
		   Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		    Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		   Input  :   FilterData -- Open filter data
          *********************************************************************************************************/          
          [DllImport("UHFAPI.dll")]
          private static extern int UHFKillTag(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData);

          /**********************************************************************************************************
            * 功能：BlockWrite 特定长度的数据到标签的特定地址
			 Function: Blockwrite specified  length of data to specified address
            * 输入：uAccessPwd -- 4字节密码
			 Input  :   uAccessPwd -- 4 bytes password
            * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
			  Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
            * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
			 Input  :   FilterStartaddr -- Open filter start address,unit : byte
            * 输入：FilterLen -- 启动过滤的长度， 单位：字节
			 Input  :   FilterLen -- Open filter length, unit : byte
            * 输入：FilterData -- 启动过滤的数据
			  Input  :   FilterData -- Open filter data
            * 输入：uBank -- 块号  1：EPC, 2:TID, 3:USR
			   Input:   uBank -- Bank number 1: EPC,2: TID, 3:USR.
            * 输入：uPtr --  写入数据的起始地址， 单位：字
			 	Input :   uPtr --  Write data start address,unit : word.
            * 输入：uCnt --   写入数据的长度， 单位：字
			  Input :   uCnt -- Write data length,unit : word.
            * 输入：uWriteDatabuf --  写入的数据
			  Input :   uWriteDatabuf --  Data
            *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFBlockWriteData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf);

          /**********************************************************************************************************
          * 功能：BlockErase 特定长度的数据到标签的特定地址
		  Function: BlockErase specified  length of data to specified address
          * 输入：uAccessPwd -- 4字节密码
		   Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		  Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		   Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		   Input  :   FilterData -- Open filter data
          * 输入：uBank -- 块号  1：EPC, 2:TID, 3:USR
		   Input:   uBank -- Bank number 1: EPC,2: TID, 3:USR.
          * 输入：uPtr --  读取数据的起始地址， 单位：字
		   Input  :   uPtr --  Read data start address,unit : word
          * 输入：uCnt --  读取数据的长度， 单位：字
		   Input  :   uCnt --  Read data length , unit :  word
          *********************************************************************************************************/       
          [DllImport("UHFAPI.dll")]
          private static extern int UHFBlockEraseData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt);
          /**********************************************************************************************************
          * 功能：设置QT命令参数
		  Function: Set QT command parameters.
          * 输入：uAccessPwd -- 4字节密码
		    Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		    Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		   Input  :   FilterData -- Open filter data
          * 输入：QTData --  bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  bit1：(0:表示启用private Memory map, 1：启用public memory map)
		    Input ：QTData --  bit0：（0：No close range control ， 1：Open close range control）  bit1：(0: Openprivate Memory map, 1：Open public memory map)
          *********************************************************************************************************/
          [DllImport("UHFAPI.dll")]
          private static extern int UHFSetQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData);
          /**********************************************************************************************************
          * 功能：获取QT命令参数
		    Function: Get QT command parameters
          * 输入：uAccessPwd -- 4字节密码
             Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		   Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		   Input  :   FilterData -- Open filter data
          * 输出：QTData --  bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  bit1：(0:表示启用private Memory map, 1：启用public memory map)
		    Output ：QTData --  bit0：（0：No close range control ， 1：Open close range control）  bit1：(0: Openprivate Memory map, 1：Open public memory map)
          *********************************************************************************************************/        
          [DllImport("UHFAPI.dll")]
          private static extern int UHFGetQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, ref byte QTData);
          /**********************************************************************************************************
          * 功能：QT标签读操作
		  Function: Read QT tag 
          * 输入：uAccessPwd -- 4字节密码
		    Input  :   uAccessPwd -- 4 bytes password
          * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		    Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
          * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		  Input  :   FilterStartaddr -- Open filter start address,unit : byte
          * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		   Input  :   FilterLen -- Open filter length, unit : byte
          * 输入：FilterData -- 启动过滤的数据
		    Input  :   FilterData -- Open filter data
          * 输入：QTData --  bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  
		    Input :   QTData --  bit0：（0：no close range control ， 1：open close range control）  
          * 输入：uBank -- 块号  1：EPC, 2:TID, 3:USR
		     Input:   uBank -- Bank number 1: EPC,2: TID, 3:USR.
          * 输入：uPtr --  读取数据的起始地址， 单位：字
		      Input  :   uPtr --  Read data start address,unit : word
          * 输入：uCnt --  读取数据的长度， 单位：字
		      Input  :   uCnt --  Read data length , unit :  word
          * 输出：uReadDatabuf --  读出的数据
		     Output :  uReadDatabuf --  Data
          * 输出：uReadDataLen --  读出的数据长度
		     Output :  uReadDataLen -- Data length 
          *********************************************************************************************************/
        [DllImport("UHFAPI.dll")]
          private static extern int UHFReadQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData, byte uBank, int uPtr, byte uCnt, byte[] uReadDatabuf, ref byte uReadDataLen);
        /**********************************************************************************************************
        * 功能：QT标签写操作
		 Function : Write QT tag.
        * 输入：uAccessPwd -- 4字节密码
		 Input  :   uAccessPwd -- 4 bytes password
        * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		 Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
        * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		 Input  :   FilterStartaddr -- Open filter start address,unit : byte
        * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		 Input  :   FilterLen -- Open filter length, unit : byte
        * 输入：FilterData -- 启动过滤的数据
		  Input  :   FilterData -- Open filter data
        * 输入：QTData --  bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  
		  Input :   QTData --  bit0：（0：no close range control ， 1：open close range control）
        * 输入：uBank -- 块号  1：EPC, 2:TID, 3:USR
		   Input:   uBank -- Bank number 1: EPC,2: TID, 3:USR.
        * 输入：uPtr --  读取数据的起始地址， 单位：字
		    Input  :   uPtr --  Read data start address,unit : word
        * 输入：uCnt --  读取数据的长度， 单位：字
		    Input  :   uCnt --  Read data length , unit :  word
        * 输入：uWriteDatabuf --  写入的数据
		    Input : uWriteDatabuf --  Data
        *********************************************************************************************************/
        [DllImport("UHFAPI.dll")]
        private static extern int UHFWriteQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf);
        /**********************************************************************************************************
        * 功能：Block Permalock操作
		 Function: Block Permlock
        * 输入：uAccessPwd -- 4字节密码
		  Input:    uAccessPwd -- 4 bytes password
        * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		  Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
        * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		  Input :   FilterStartaddr -- Open filter start address,unit : byte
        * 输入：FilterLen -- 启动过滤的长度， 单位：字节
		  Input:    FilterLen -- Open filter length, unit : byte
        * 输入：FilterData -- 启动过滤的数据
		  Input  :   FilterData -- Open filter data
        * 输入：ReadLock --  bit0：（0：表示Read ， 1：表示Permalock）  
		  Input :   ReadLock --  bit0：（0：for Read ， 1：for Permalock）  
        * 输入：uBank -- 块号  1：EPC, 2:TID, 3:USR
		  Input :   uBank -- Block 1：EPC, 2:TID, 3:USR
        * 输入：uPtr --  Block起始地址 ，单位为16个块
		  Input :   uPtr --  Block start address ，unit: 16 blocks
        * 输入：uRange --  Block范围，单位为16个块
		  Input :   uRange --  Block range,unit : 16 blocks.
        * 输入：uMaskbuf -- 块掩码数据，2个字节，16bit 对应16个块
		  Input :  uMaskbuf  -- Block mask data , 2 bytes, 16 bits for 16 blocks.
        *********************************************************************************************************/        
        [DllImport("UHFAPI.dll")]
        private static extern int UHFBlockPermalock(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte ReadLock, byte uBank, int uPtr, byte uRange, byte[] uMaskbuf);

        /**********************************************************************************************************
        * 功能：激活或失效EM4124标签
		 Function: Activate or Deactivate EM4124 tag.
        * 输入：cmd --整形
		  Input  :  cmd  --init class
        * 输入：uAccessPwd -- 4字节密码]
		  Input:    uAccessPwd -- 4 bytes password
        * 输入：FilterBank -- 启动过滤的bank号， 1：EPC, 2:TID, 3:USR
		Input ：FilterBank -- Start filter bank number， 1：EPC, 2:TID, 3:USR
        * 输入：FilterStartaddr -- 启动过滤的起始地址， 单位：字节
		 Input :   FilterStartaddr -- Open filter start address,unit : byte
        * 输入：FilterData -- 启动过滤的数据
		  Input  :   FilterData -- Open filter data
        *********************************************************************************************************/
        [DllImport("UHFAPI.dll")]
         private static extern  int UHFDeactivate (int cmd,byte[] uAccessPwd, byte FilterBank,int FilterStartaddr,int FilterLen, byte[] FilterData);

          private static UHFAPI uhf = null;
          private UHFAPI() { }
          public static UHFAPI getInstance()
          {
              if (uhf == null)
                  uhf = new UHFAPI();
              return uhf;
          }
  #region 串口、版本号、ID  
                 Serial port. Version number,ID.
          /// <summary>
           /// 打开串口
		   Open serial port
           /// </summary>
           /// <param name="com">串口号：0,1,2....</param>               Com port number
           /// <returns>返回0表示成功，返回1表示失败</returns>      If returns 0,sucess, if return 1 ,false
		   
		   
          public bool Open(int comName)
          {
              int result=ComOpen(comName);
              if (result == 0)
              {
                  return true;
              }
              return false;
          }
            /// <summary>
            /// 关闭串口   Close serial port
            /// </summary>
            /// <returns></returns>
          public bool Close() {
              ClosePort();
              return true;
          }
          /// <summary>
          /// 获取硬件版本 Get hardware version
          /// </summary>
          /// <returns></returns>
          public string GetHardwareVersion()
          {
              byte[] version = new byte[50];
              if (UHFGetHardwareVersion(version) == 0)
              {
                  int len = version[0];
                  byte[] versionTemp = new byte[len];
                  Array.Copy(version, 1, versionTemp,0,len);
                  return System.Text.Encoding.ASCII.GetString(versionTemp);// DataConvert.ByteArrayToHexString(versionTemp);
              }
              return string.Empty;
          }
          /// <summary>
          /// 获取软件版本 Get software version
          /// </summary>
          /// <returns></returns>
          public string GetSoftwareVersion()
          {
              byte[] version = new byte[50];
              if (UHFGetSoftwareVersion(version) == 0)
              {
                  int len = version[0];
                  byte[] versionTemp = new byte[len];
                  Array.Copy(version, 1, versionTemp, 0, len);
                  return System.Text.Encoding.ASCII.GetString(versionTemp) ;//DataConvert.ByteArrayToHexString(versionTemp);
              }
              return string.Empty;
          }
          /// <summary>
          /// 获取设备ID Get device ID
          /// </summary>
          /// <returns>id--整型ID号</returns> ID class
          public int GetUHFGetDeviceID()
          {
               int id=-1;
               UHFGetDeviceID(ref id);
               return id;
          }
  #endregion

  #region 频率、功率  Frequency, power
          /// <summary>
          /// 设置功率 Set power
          /// </summary>
          /// <param name="save">1:保存设置   0：不保存</param>  Save , 1, save settings, 0: no saving.
          /// <param name="uPower">功率（DB）</param>    Power.
         /// <returns></returns>
          public bool SetPower(byte save, byte uPower) {
              if (UHFSetPower(save, uPower) == 0)
                  return true;
              return false;
          }
        /// <summary>
        /// 获取功率  Get power
        /// </summary>
        /// <param name="uPower">功率（DB）</param> Power 
        /// <returns></returns>
          public bool GetPower(ref byte uPower) {
              if (UHFGetPower(ref uPower) == 0)
              {
                  return true;
              }
              return false;
          }
          /// <summary> 
          /// 获取跳频  Get fequency hop
          /// </summary>
          /// <param name="Freqbuf">Freqbuf[0]--频点个数， Freqbuf[1]..[x]--频点数组（整型）</param>
		 // Frequency buffer, Freqbuf[0]--Frequency hop number， Freqbuf[1]..[x]--Frequency group
          /// <returns></returns>
          public bool GetJumpFrequency(ref int[] Freqbuf)
          {
              int[] temp=new int[512];
              if (UHFGetJumpFrequency(temp) == 0)
              {
                  int len=temp[0];
                  int[] freqData = new int[len];
                  Array.Copy(temp,1,freqData,0,len);
                  Freqbuf = freqData;
                  return true;
              }
              return false;
          }
          /// <summary>
          /// 设置跳频 Set frequency hop
          /// </summary>
          /// <param name="nums">跳频个数</param>  
		  ///Frequency hop number
          /// <param name="Freqbuf">Freqbuf--频点数组（整型） ，如920125，921250.....</param>
		  ///Frequency group,for example : 920125，921250.....
          /// <returns></returns>
          public bool SetJumpFrequency(byte nums, int[] Freqbuf)
          {
              if (UHFSetJumpFrequency(nums, Freqbuf) == 0)
              {
                  return true;
              }
              return false;
          }
 #endregion

  #region session
        /// <summary>
        /// 设置session  Set session
        /// </summary>
        /// <param name="Target"></param>
        /// <param name="Action"></param>
        /// <param name="T"></param>
        /// <param name="Q"></param>
        /// <param name="StartQ"></param>
        /// <param name="MinQ"></param>
        /// <param name="MaxQ"></param>
        /// <param name="D"></param>
        /// <param name="C"></param>
        /// <param name="P"></param>
        /// <param name="Sel"></param>
        /// <param name="Session"></param>
        /// <param name="G"></param>
        /// <param name="LF"></param>
        /// <returns></returns>
          public bool SetGen2(byte Target, byte Action, byte T, byte Q,
                                byte StartQ, byte MinQ,
                                byte MaxQ, byte D, byte C, byte P,
                                byte Sel, byte Session, byte G, byte LF)
          {
              if (UHFSetGen2(Target, Action, T, Q, StartQ, MinQ, MaxQ, D, C, P, Sel, Session, G, LF) == 0)
              {
                  return true;
              }
              return false;
          }
          /// <summary>
          /// 获取session  Get session
          /// </summary>
          /// <param name="Target"></param>
          /// <param name="Action"></param>
          /// <param name="T"></param>
          /// <param name="Q"></param>
          /// <param name="StartQ"></param>
          /// <param name="MinQ"></param>
          /// <param name="MaxQ"></param>
          /// <param name="D"></param>
          /// <param name="Coding"></param>
          /// <param name="P"></param>
          /// <param name="Sel"></param>
          /// <param name="Session"></param>
          /// <param name="G"></param>
          /// <param name="LF"></param>
          /// <returns></returns>
          public bool GetGen2(ref byte Target, ref byte Action, ref byte T, ref byte Q,
                     ref byte StartQ, ref byte MinQ,
                     ref byte MaxQ, ref byte D, ref byte Coding, ref byte P,
                     ref byte Sel, ref byte Session, ref byte G, ref byte LF)
          {
              if (UHFGetGen2(ref Target, ref Action, ref T, ref Q, ref StartQ, ref MinQ, ref MaxQ, ref D, ref Coding, ref P, ref Sel, ref Session, ref G, ref LF) == 0)
              {
                  return true;
              }
              return false;
          }
  #endregion

          /// <summary>
          /// 设置CW 
		  /// Set CW
          /// </summary>
          /// <param name="flag">flag -- 1:开CW，  0：关CW</param>
		  /// flag-- 1.open CW, 0: close CW.
          /// <returns></returns>
          public bool SetCW(byte flag)
          {
              if (UHFSetCW(flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
           /// 功能：获取CW
		   ///Function: Get CW.
           /// </summary>
           /// <param name="flag">flag -- 1:开CW，  0：关CW</param>
		   /// flag-- 1.Open CW, 0 Close CW.
           /// <returns></returns>
          public bool GetCW(ref byte flag)
          {
              if (UHFGetCW(ref flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
           /// 天线设置
		   /// Antenna settings
          /// </summary>
          /// <param name="saveflag">saveflag -- 1:掉电保存，  0：不保存</param>
		  /// saveflag -- 1.power fail saving,0, no saving.
          /// <param name="buf">buf--2bytes, 共16bits, 每bit 置1选择对应天线</param>
		  ///buf-- 2 bytes, 16 bits in total, different antenna fro every bit.
          /// <returns></returns>
          public bool SetANT(byte saveflag, byte[] buf)
          {
              if (UHFSetANT( saveflag,  buf) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
           /// 获取天线设置 Get antenna settings.
           /// </summary>
          /// <param name="buf">buf--2bytes, 共16bits</param>
           /// <returns></returns>
          public bool GetANT(byte[] buf)
          {
              if (UHFGetANT(buf) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 区域设置 Regional settings 
           /// </summary>
          /// <param name="saveflag">1:掉电保存，  0：不保存</param>
		  ///saveflag 1.power fail saving,0: no saving.
          /// <param name="region">0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)</param>
           /// <returns></returns>
          public bool SetRegion(byte saveflag, byte region)
          {
              if (UHFSetRegion(saveflag, region) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 获取区域设置 Get region settings
           /// </summary>
          /// <param name="region"> 0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)</param>
           /// <returns></returns>
          public bool GetRegion(ref byte region)
          {
              if (UHFGetRegion(ref region) == 0)
              {
                  return true;
              }
              return false;
          }
          /// <summary>
          /// 获取模块温度 Get module temperature.
          /// </summary>
          /// <param name="temperature">回传的温度</param>
		  /// Temperature returned.
          /// <returns>返回true表示获取成功，temperature参数可以使用。返回false表示获取失败，temperature参数不可以使用</returns>
		  /// if return true, success, temperature parameter can be used, if return false, failure,  temperature parameter can not be used.
          public string GetTemperature()
          {
              int temperature = 0;
              if (UHFGetTemperature(ref temperature) == 0)
              {
                  return temperature.ToString();
              }
              return string.Empty;
          }
           /// <summary>
           /// 设置温度保护 Set temperature protect
          /// </summary>
          /// <param name="flag">1:温度保护， 0：无温度保护</param>
		  /// flag.1: temperature protect,0: no temperature protect.
          /// <returns></returns>
          public bool SetTemperatureProtect(byte flag)
          {
              if (UHFSetTemperatureProtect(flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
           /// 获取温度保护  Get temperature protect
           /// </summary>
           /// <param name="flag">1:温度保护， 0：无温度保护</param>
		   /// flag 1:  temperature protect ,0 : no temperature protect
           /// <returns></returns>
          public bool GetTemperatureProtect(ref byte flag)
          {
              if (UHFGetTemperatureProtect(ref flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 设置天线工作时间 Set antenna working time.
           /// </summary> 
          /// <param name="antnum">天线号</param> Antenna number
          /// <param name="saveflag">1:掉电保存， 0：不保存</param>
		  /// saveflag 1: power fail saving, 0; no saving.
          /// <param name="WorkTime">工作时间 ，单位ms, 范围 10-65535ms</param>
		  ///Working time: unit: ms.range: 10-65535ms.
           /// <returns></returns>
          public bool SetANTWorkTime(byte antnum, byte saveflag, int WorkTime)
          {
              if (UHFSetANTWorkTime(antnum, saveflag, WorkTime) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 获取天线工作时间 Get antenna working time.
           /// </summary>
          /// <param name="antnum">天线号</param> antenna number.
          /// <param name="WorkTime">工作时间 ，单位ms, 范围 10-65535ms</param>
		  ///working time, unit ms, range 10-65535 ms.
           /// <returns></returns>
          public bool GetANTWorkTime(byte antnum, ref int WorkTime)
          {
              if (UHFGetANTWorkTime(antnum, ref   WorkTime) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 设置链路组合 Set RF Link.
           /// </summary>
          /// <param name="saveflag">1:掉电保存， 0：不保存</param>
		  /// saveflag,1: power fail saving,0: no saving.
          /// <param name="mode">0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ</param>
           /// <returns></returns>
          public bool SetRFLink(byte saveflag, byte mode)
          {

              if (UHFSetRFLink(saveflag, mode) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 获取链路组合 Get RF Link.
           /// </summary>
          /// <param name="uMode">0:DSB_ASK/FM0/40KHZ , 1:PR_ASK/Miller4/250KHZ , 2:PR_ASK/Miller4/300KHZ, 3:DSB_ASK/FM0/400KHZ</param>
           /// <returns></returns>
          public bool GetRFLink(ref byte uMode)
          {
              if (UHFGetRFLink(ref uMode) == 0)
                  return true;

              return false;
          }
          /// <summary>
          /// 设置FastID功能
		  /// Set FastID function.
          /// </summary>
          /// <param name="flag">1:开启， 0：关闭</param>
		  /// flag, 1,open, 2,close.
         /// <returns></returns>
        public bool SetFastID(byte flag)
        {
            if (UHFSetFastID(flag) == 0)
            {
                return true;
            }
            return false;
        }
          /// <summary>
        /// 获取FastID功能
		///Get FastID function
          /// </summary>
        /// <param name="flag">1:开启， 0：关闭</param>
		/// flag,1.open.2:close.
          /// <returns></returns>
        public bool GetFastID(ref byte flag)
        {
            if (UHFGetFastID(ref   flag) == 0)
                return true;
            return false;

        }
        /// <summary>
        /// 设置Tagfocus功能
		/// Set Tagfocus function
        /// </summary>
        /// <param name="flag">1:开启， 0：关闭</param>
		/// flag.1:open,0: close.
        /// <returns></returns>
          public bool SetTagfocus(byte flag)
          {
              if (UHFSetTagfocus(flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 获取Tagfocus功能
		  /// Get Tagfocus function.
           /// </summary>
          /// <param name="flag">1:开启， 0：关闭</param>
		  /// flag,1: open, 0: close.
           /// <returns></returns>
          public bool GetTagfocus(ref byte flag)
          {
              if (UHFGetTagfocus(ref  flag) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 设置软件复位
		  ///Set software reset
         /// </summary>
         /// <returns></returns>
        public bool SetSoftReset() {
              if (UHFSetSoftReset() == 0)
                  return true;
              return false;
          }
           /// <summary>
            /// 设置Dual和Single模式
			/// Set Dual and Single mode
           /// </summary>
           /// <param name="saveflag">1:掉电保存， 0：不保存</param>
		   /// 1: Power fail saving, 0: no saving.
           /// <param name="mode">1:设置Singel模式， 0：设置Dual模式</param>
		   /// 1.Set single mode, 0: set dual mode.
           /// <returns></returns>
          public bool SetDualSingelMode(byte saveflag, byte mode)
          {
              if (UHFSetDualSingelMode(saveflag, mode) == 0)
                  return true;
              return false;
          }
           /// <summary>
          /// 获取Dual和Single模式
		  /// Get Dual and Single mode
           /// </summary>
          /// <param name="mode">1:设置Singel模式， 0：设置Dual模式</param>
		  /// 1.Single mode, 2 Dual mode.
           /// <returns></returns>
          public bool GetDualSingelMode(ref byte mode)
          {
              if (UHFGetDualSingelMode(ref  mode) == 0)
                  return true;
              return false;
          }
           /// <summary>
          /// 设置寻标签过滤设置 
		  /// Set filter settings.
           /// </summary>
          /// <param name="saveflag">1:掉电保存， 0：不保存</param>
		  ///  1: Power fail saving, 0: no saving.
          /// <param name="bank">0x01:EPC , 0x02:TID, 0x03:USR</param>
          /// <param name="startaddr">起始地址，单位：字节</param>
		  /// Start address,unit:byte.
          /// <param name="datalen">数据长度， 单位:字节</param>
		  /// Data length,unit:bytes.
          /// <param name="databuf">数据</param>
           /// <returns></returns>
          public bool SetFilter(byte saveflag, byte bank, int startaddr, int datalen, byte[] databuf)
          {
              if (UHFSetFilter(saveflag, bank, startaddr, datalen, databuf)==0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 设置EPC和TID模式
		  /// Set EPC+ TID mode
           /// </summary>
          /// <param name="saveflag">1:掉电保存， 0：不保存</param>
		  ///  1: Power fail saving, 0: no saving.
          /// <param name="mode">1：开启EPC和TID， 0:关闭</param>
		  /// 1: Open EPC+TID,0: Close.
          /// <returns></returns>
          public bool SetEPCTIDMode(byte saveflag, byte mode)
          {
              if (UHFSetEPCTIDMode(saveflag, mode) == 0)
                  return true;
              return false;
          }
           /// <summary>
          /// 获取EPC和TID模式
		  ///Get EPC+TID mode.
           /// </summary>
          /// <param name="mode">1：开启EPC和TID， 0:关闭</param>
		  /// 1: Open EPC+ TID,0 : Close.
           /// <returns></returns>
          public bool GetEPCTIDMode(ref byte mode)
          {
              if (UHFGetEPCTIDMode(ref mode) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          /// 恢复出厂设置
		  /// Restore factory defaults.
           /// </summary>
           /// <returns></returns>
          public bool SetDefaultMode()
          {
              if (UHFSetDefaultMode() == 0)
                  return true;
              return false;
          }
            /// <summary>
            /// 单次盘存标签
			/// Inventory single tag.
            /// </summary>
            /// <param name="uLenUii">UII长度</param>
			///UII length.
            /// <param name="uUii">UII数据</param>
			///UII data
            /// <returns></returns>
          private bool InventorySingle(ref byte uLenUii,ref byte[] uUii)
          {
              if (UHFInventorySingle(ref uLenUii, uUii) == 0)
                  return true;
              return false;
          }
           /// <summary>
          /// 连续盘存标签
		  ///Inventory
           /// </summary>
           /// <returns></returns>
          public bool Inventory() {

              int result=UHFInventory();
              if (result == 0)
                  return true;
              else
                  return false;
          }
           /// <summary>
          /// 停止盘存标签
		  /// Stop inventory
           /// </summary>
           /// <returns></returns>
          public bool StopGet() {

              if (UHFStopGet() == 0)
                  return true;
              else
                  return false;
                
           }
          /// <summary>
          /// 获取连续盘存标签数据
		  ///Get received inventory tag data.
          /// </summary>
          /// <param name="uLenUii">UII长度</param>
		  /// UII length.
          /// <param name="uUii">UII数据</param>
		  /// Uii data.
         /// <returns></returns>
          public bool GetReceived_EX(ref int uLenUii, ref byte[] uUii) {    
               if(UHF_GetReceived_EX(ref uLenUii, uUii)==0){
                      return true;
               }
             return false;
          }
          /// <summary>
          /// 读取数据
		  /// Read data
          /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		  /// 4 bytes password
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  /// Filter bank number: 1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		  /// Filter start address, unit: bytes
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		  /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  ///Filter data
          /// <param name="uBank">读取数据的bank</param>
		  /// Read data bank.
          /// <param name="uPtr">读取数据的起始地址， 单位：字</param>
		  /// Read data start address.unit:word.
          /// <param name="uCnt">读取数据的长度， 单位：字</param>
		  /// Read data length,unit: word.
          /// <returns>返回十六进制数据，读取失败返回""</returns>
		  /// Return hex data.
          public string ReadData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt)
          {
              try
              {
                  byte[] uReadDatabuf = new byte[512]; ;
                  int uReadDataLen = 0;
                  if (UHFReadData(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, uBank, uPtr, uCnt, uReadDatabuf, ref   uReadDataLen) == 0)
                  {
                      return DataConvert.ByteArrayToHexString(uReadDatabuf, uReadDataLen);
                  }
              }
              catch (Exception ex) { 
              
              }
          
              return string.Empty ;
          }
           /// <summary>
          /// 写标签数据区 
		  /// Write tag bank.
           /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		  ///4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  ///Filter bank number: 1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：bit</param>
		  /// Filter start address
          /// <param name="FilterLen">启动过滤的长度， 单位：bit</param>
		  ///Filter length.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
          /// <param name="uBank">写入数据的bank</param>
		  ///Write data bank.
          /// <param name="uPtr">写入数据的起始地址， 单位：字</param>
		  /// Write data start address, unit: word.
          /// <param name="uCnt">写入数据的长度， 单位：字</param>
		  /// Write data length, unit: word.
          /// <param name="uDatabuf">写入的数据</param>
		  ///  Write data.
           /// <returns></returns>
          public bool WriteData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf)
          {      
              if (UHFWriteData(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, uBank, uPtr, uCnt, uDatabuf) == 0)
              {
                  return true;
              }
              return false;
          } 
             /// <summary>
             /// LOCK标签
			 ///Lock tag.
             /// </summary>
             /// <param name="uAccessPwd"> 4字节密码</param>
			 /// 4 bytes password.
             /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
			 /// Filter bank number:  1：EPC, 2:TID, 3:USR
             /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
			 /// Filter start address.
             /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
			 /// Filter length,unit: byte.
            /// <param name="FilterData">启动过滤的数据</param>
			/// Filter data.
             /// <param name="lockbuf">3字节，第0-9位为Action位， 第10-19位为Mask位</param>
			 /// lock buffer, 3 bytes, 0-9 for Action, 10-19 for Mask.
            /// <returns></returns>
          public bool LockTag(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte[] lockbuf)
          {
              if (UHFLockTag(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, lockbuf) == 0)
              {
                  return true;
              }
              return false;
          }
           /// <summary>
          ///  KILL标签 
		  ///Kill tag.
           /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		   /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		   /// Filter bank number:  1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		   /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		   /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
           /// <returns></returns>
          public bool KillTag(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData)
          {
              if (UHFKillTag(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData) == 0)
              {

                  return true;
              }
              return false;

          }
           /// <summary>
          /// BlockWrite 特定长度的数据到标签的特定地址
		  /// BlockWrite  specified length of data to specified address.
           /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		  /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		   /// Filter bank number:  1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		   /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		   /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
          /// <param name="uBank">块号  1：EPC, 2:TID, 3:USR</param>
		  /// Block number: 1：EPC, 2:TID, 3:USR
          /// <param name="uPtr">读取数据的起始地址， 单位：字</param>
		  /// Start address of read data.unit:word.
          /// <param name="uCnt">读取数据的长度， 单位：字</param>
		  ///Read data length.
          /// <param name="uDatabuf">写入的数据</param>
		  /// Write data.
           /// <returns></returns>
          public bool BlockWriteData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf)
          {
              if (UHFBlockWriteData(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, uBank, uPtr, uCnt, uDatabuf) == 0)
              {
                  return true;
              }
              return false;
          }
            /// <summary>
           /// BlockErase 特定长度的数据到标签的特定地址
		   /// BlockErase Specified length of data to specified address.
           /// </summary>
           /// <param name="uAccessPwd">4字节密码</param>
		   /// 4 bytes password.
           /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		   /// Filter bank number:  1：EPC, 2:TID, 3:USR
           /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		   /// Filter start address.
           /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		   /// Filter length,unit: byte.
           /// <param name="FilterData">启动过滤的数据</param>
		   /// Filter data.
           /// <param name="uBank">块号  1：EPC, 2:TID, 3:USR</param>
		   /// Block number: 1：EPC, 2:TID, 3:USR
           /// <param name="uPtr">读取数据的起始地址， 单位：字</param>
		    /// Start address of read data.unit:word.
           /// <param name="uCnt">读取数据的长度， 单位：字</param>
		    ///Read data length.
		   
           /// <returns></returns>
          public bool BlockEraseData(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte uBank, int uPtr, byte uCnt)
          {
              if (UHFBlockEraseData(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, uBank, uPtr, uCnt) == 0)
              {

                  return true;
              }
              return false;
          }
 #region QT 相关
           /// <summary>
          /// 设置QT命令参数
		  /// Set QT command paramters.
          /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		  /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  /// Filter bank number:  1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		   /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		  /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		   /// Filter data.
          /// <param name="QTData">bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  bit1：(0:表示启用private Memory map, 1：启用public memory map)</param>
		  /// <param name="QTData">bit0：（0：No close range control， 1：Close range control）  bit1：(0:Activate private Memory map, 1：Activate public memory map)</param>
          /// <returns></returns>
          public bool SetQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData)
          {
              if (UHFSetQT(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, QTData) == 0) { return true; }
              return false;

          } 
            /// <summary>
          /// 获取QT命令参数
		  /// Get QT command parameters.
            /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		  /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  /// Filter bank number:  1：EPC, 2:TID, 3:USR
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		  /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		   /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
		  
          /// <param name="QTData">bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  bit1：(0:表示启用private Memory map, 1：启用public memory map)</param>
		  /// <param name="QTData">bit0：（0：No close range control， 1：Close range control）  bit1：(0:Activate private Memory map, 1：Activate public memory map)</param>
            /// <returns></returns>
          public bool GetQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData,ref byte QTData)
          {
              if (UHFGetQT(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, ref QTData) == 0)
              {
                  return true;
              }
              return false;
          }
             /// <summary>
          /// QT标签读操作
		  ///  Read QT tag.
		  /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
          /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  /// Filter bank number:  1：EPC, 2:TID, 3:USR     
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		   /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		   /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
          /// <param name="QTData">bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制）  </param>
		  ///bit0：（0：No close range control， 1：Close range control）
          /// <param name="uBank">块号  1：EPC, 2:TID, 3:USR</param>
		  ///Block number  1：EPC, 2:TID, 3:USR
          /// <param name="uPtr">读取数据的起始地址， 单位：字</param>
		  /// Read data start address.unit: word.
          /// <param name="uCnt">读取数据的长度， 单位：字</param>
		  /// Read data length.unit: word.
          /// <param name="uReadDatabuf">读出的数据</param>
		  /// Read data.
          /// <param name="uReadDataLen">读出的数据长度</param>
		  ///Read data length.
             /// <returns></returns>
          public string ReadQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData, byte uBank, int uPtr, byte uCnt)
          {
              byte[] uReadDatabuf=new byte[512];
              byte uReadDataLen = 0;
              if (UHFReadQT(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, QTData, uBank, uPtr, uCnt, uReadDatabuf, ref uReadDataLen) == 0)
              {
                  string strData = DataConvert.ByteArrayToHexString(uReadDatabuf, uReadDataLen); //BitConverter.ToString(uReadDatabuf, 0, uReadDataLen).Replace("-", "");
                  return strData;
              }
              return string.Empty;
          }
             /// <summary>
          ///   QT标签写操作
		  ///   Write QT tag.
           /// </summary>
          /// <param name="uAccessPwd"> 4字节密码</param>
		   /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		   /// Filter bank number:  1：EPC, 2:TID, 3:USR     
          /// <param name="FilterStartaddr"> 启动过滤的起始地址， 单位：字节</param>
		  /// Filter start address.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		  /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
          /// <param name="QTData">bit0：（0：表示无近距离控制 ， 1：表示启用近距离控制） </param>
		  ///bit0：（0：No close range control， 1：Close range control）
          /// <param name="uBank">块号  1：EPC, 2:TID, 3:USR</param>
		  ///Block number  1：EPC, 2:TID, 3:USR
          /// <param name="uPtr">读取数据的起始地址， 单位：字</param>
		   /// Read data start address.unit: word.
          /// <param name="uCnt">读取数据的长度， 单位：字</param>
		    /// Read data length.unit: word.
          /// <param name="uDatabuf">写入的数据</param>
		  ///Write data.
             /// <returns></returns>
          public bool WriteQT(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte QTData, byte uBank, int uPtr, byte uCnt, byte[] uDatabuf)
          {
              if (UHFWriteQT(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, QTData, uBank, uPtr, uCnt, uDatabuf) == 0)
              {
                  return true;
              }
              return false;
          }
 #endregion 
           /// <summary>
          /// Block Permalock操作
		  /// Block Permalock.
           /// </summary>
          /// <param name="uAccessPwd">4字节密码</param>
		   /// 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		   /// Filter bank number:  1：EPC, 2:TID, 3:USR     
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：字节</param>
		  /// Read data start address.unit: word.
          /// <param name="FilterLen">启动过滤的长度， 单位：字节</param>
		  /// Filter length,unit: byte.
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
          /// <param name="ReadLock">bit0：（0：表示Read ， 1：表示Permalock）  </param>
		  /// bit0: (0: read, 1: Permalock.)
          /// <param name="uBank">块号  1：EPC, 2:TID, 3:USR</param>
		  ///Block number  1：EPC, 2:TID, 3:USR
          /// <param name="uPtr">Block起始地址 ，单位为16个块</param>
		  ///Block start address, unit: 16 blocks.
          /// <param name="uRange">Block范围，单位为16个块</param>
		  /// Block range, units: 16 blocks.
          /// <param name="uMaskbuf">块掩码数据，2个字节，16bit 对应16个块</param>
		  /// Block mask data, 2 bytes, 16 bit for 16 blocks.
           /// <returns></returns>
          public bool  BlockPermalock(byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData, byte ReadLock, byte uBank, int uPtr, byte uRange, byte[] uMaskbuf)
          {
              if (UHFBlockPermalock(uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData, ReadLock, uBank, uPtr, uRange, uMaskbuf) == 0)
              {
                  return true;

              }
              return false;
          }
         
          //读取epc
		  //Read EPC.
          public bool uhfGetReceived(ref string epc, ref string tid, ref string rssi, ref string ant)
          {
              int  uLen = 0;
              byte[] bufData = new byte[150];
              if (GetReceived_EX(ref uLen, ref bufData))
              {
                  //  uUii = 1byteUII长度+UII数据+1byteTID数据+TID+2bytesRSSI
				  //   uUii = 1byteUII lengtg +UII data +1byteTID data+TID+2bytesRSSI
                  string epc_data = string.Empty;
                  string uii_data = string.Empty;//uii data
                  string tid_data = string.Empty; //tid data
                  string rssi_data = string.Empty;
                  string ant_data = string.Empty;

                  int uii_len = bufData[0];//uii length
                  int tid_leng = bufData[uii_len + 1];//tid data length
                  int tid_idex = uii_len + 2;//tid start address.
                  int rssi_index = 1 + uii_len + 1 + tid_leng;
                  int ant_index = rssi_index + 2;

                  string strData = BitConverter.ToString(bufData, 0, uLen).Replace("-", "");
                  epc_data = strData.Substring(6, uii_len * 2 - 4);  //Epc
                  tid_data = strData.Substring(tid_idex * 2, tid_leng * 2); //Tid
                  string temp = strData.Substring(rssi_index * 2, 4);
                  rssi_data = ((Convert.ToInt32(temp, 16) - 65535) / 10).ToString();// RSSI  =  (0xFED6   -65535)/10
                  ant_data = Convert.ToInt32((strData.Substring(ant_index * 2, 2)), 16).ToString();

                  epc = epc_data;
                  tid = tid_data;
                  rssi = rssi_data;
                  ant = ant_data;
                  return true;
              }
              else
              {
                  return false;
              }
          }
          public bool InventorySingle(ref string epc)
          {
              string tid = string.Empty;
              string rssi = string.Empty;
              byte  uLen = 0;
              byte[] bufData = new byte[150];
              if (UHFInventorySingle(ref uLen,  bufData)==0)
              {
                  //  uUii = 1byteUII长度+UII数据+1byteTID数据+TID+2bytesRSSI
				  //  uUii = 1byteUII lengtg +UII data +1byteTID data+TID+2bytesRSSI
                  string epc_data = string.Empty;
                  string uii_data = string.Empty;//uii data 
                  string tid_data = string.Empty; //tid data
                  string rssi_data = string.Empty;

                 // int uii_len = bufData[0];//uii length
                  int epclen = ((bufData[0] >> 3)) * 2;
                 // int tid_leng = bufData[uii_len + 1];//tid data length
                //  int tid_idex = uii_len + 2;//tid start address
                 // int rssi_index = 1 + uii_len + 1 + tid_leng;

                  string strData = BitConverter.ToString(bufData, 0, uLen).Replace("-", "");
                  epc_data = strData.Substring(4, epclen*2);  //Epc
               //   tid_data = strData.Substring(tid_idex * 2, tid_leng * 2); //Tid
              //    string temp = strData.Substring(rssi_index * 2, 4);
              //    rssi_data = ((Convert.ToInt32(temp, 16) - 65535) / 10).ToString();// RSSI  =  (0xFED6   -65535)/10

                  epc = epc_data;
                //  tid = tid_data;
                //  rssi = rssi_data;
                  return true;
              }
              else
              {
                  return false;
              }
          }

    
            /// <summary>
          /// 激活或失效EM4124标签
		  /// Activate or deactivate EM4124 tag.
          /// </summary>
          /// <param name="cmd"></param>
          /// <param name="uAccessPwd">4字节密码</param>
		   // 4 bytes password.
          /// <param name="FilterBank">启动过滤的bank号， 1：EPC, 2:TID, 3:USR</param>
		  /// Filter bank number:  1：EPC, 2:TID, 3:USR     
          /// <param name="FilterStartaddr">启动过滤的起始地址， 单位：bit</param>
		  /// Filter start address
          /// <param name="FilterLen">启动过滤的数据长度</param>
		  /// Filter data length
          /// <param name="FilterData">启动过滤的数据</param>
		  /// Filter data.
            /// <returns></returns>
          public bool Deactivate(int cmd, byte[] uAccessPwd, byte FilterBank, int FilterStartaddr, int FilterLen, byte[] FilterData)
          {
              if (UHFDeactivate(cmd, uAccessPwd, FilterBank, FilterStartaddr, FilterLen, FilterData) == 0)
                  return true;
              else
                  return false;

          }
        

        
         
    }
}
